/*
 * KEnemy.cpp
 *
 *  Created on: Oct 6, 2008
 *      Author: Santi
 */

#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif

#ifdef _WIN32
#include <windows.h>
#endif

#include "GLTManager.h"

#include "KEnemy.h"

#include "KObjectCreator.h"

KEnemy::KEnemy(int x, int y, int sfx_volume) : KObject(x,y,sfx_volume)
{
	m_class = kenemy_symbol;

	m_keep_angle = true;
	m_health = 1;
	m_points_on_kill = 10;
	
	m_shadow_tile = 0;
	m_shadow_offset = 20;
}

KEnemy::~KEnemy() {
}


bool KEnemy::is_a(Symbol *c)
{
    if (c->cmp(kenemy_symbol))
        return true;

    return KObject::is_a(c);
} /* KPlayer::is_a */


bool KEnemy::is_a(char *c)
{
    bool retval;
    Symbol *s = new Symbol(c);

    retval = is_a(s);

    delete s;

    return retval;
} /* KPlayer::is_a */



bool KEnemy::cycle(List<VirtualController> *vcl, Knightmare *game, GLTManager *GLTM, SFXManager *SFXM)
{
	if (!KObject::cycle(vcl,game,GLTM,SFXM)) return false;	
	return true;
}


bool KEnemy::hit(Weapon *weapon,int damage)
{
	if (m_health>0) {
		m_health-=damage;
		return true;
	} else {
		return false;
	}
}


void KEnemy::draw(float angle,int x_offset,int y_offset,GLTManager *GLTM)
{
	// draw shadow:
	if (m_shadow_tile!=0) 
		m_shadow_tile->draw(m_x+x_offset,m_y+y_offset+m_shadow_offset,0,0,1);

	KObject::draw(angle,x_offset,y_offset,GLTM);
} /* KEnemy::draw */

