/*
 * KPlayer.h
 *
 *  Created on: Oct 2, 2008
 *      Author: Santi Ontan
 */

#ifndef KPLAYER_H_
#define KPLAYER_H_

#include "KObject.h"
#include "GLTManager.h"

#define PLAYER_STATE_IDLE			0
#define PLAYER_STATE_WALKING		1
#define	PLAYER_STATE_PAUSE			2
#define PLAYER_STATE_FIRE			3
#define PLAYER_STATE_DYING			4

#define WEAPON_ARROW		0
#define WEAPON_D_ARROW		1
#define WEAPON_KNIFE		2
#define WEAPON_D_KNIFE		3
#define WEAPON_FIREBALL1	4
#define WEAPON_FIREBALL2	5
#define WEAPON_BOOMERANG1	6
#define WEAPON_BOOMERANG2	7

#define N_WEAPONS			8

class KPlayer : public KObject {
public:
	KPlayer(int x, int y, int sfx_volume,int ID);	// The ID corresponds to the appropriate VirtualController
	virtual ~KPlayer();

    virtual bool cycle(List<class VirtualController> *vcl, class Knightmare *game, class GLTManager *GLTM, SFXManager *SFXM);
	virtual void draw(float angle,int x_offset,int y_offset,GLTManager *GLTM);

    virtual bool is_a(Symbol *c);
    virtual bool is_a(char *c);
	
	void weaponDisappeared(class Weapon *w);
	
	void weaponChangeEffect(int weapon,Knightmare *game,SFXManager *SFXM);

protected:
	int m_ID;

	float m_move_speed;
	int m_weapon,m_weapon_count;
	
	int m_shadow_offset;
	GLTile *m_shadow_tile;
};

#endif /* KPLAYER_H_ */
